/********************************************************************************************
 *                                                                                          *
 * Copyright (C) 2017 Armin Felder, Dennis Beier                                            *
 * This file is part of RocketChatMobileEngine <https://git.fairkom.net/chat/fairchat>.     *
 *                                                                                          *
 * RocketChatMobileEngine is free software: you can redistribute it and/or modify           *
 * it under the terms of the GNU General Public License as published by                     *
 * the Free Software Foundation, either version 3 of the License, or                        *
 * (at your option) any later version.                                                      *
 *                                                                                          *
 * RocketChatMobileEngine is distributed in the hope that it will be useful,                *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                            *
 * GNU General Public License for more details.                                             *
 *                                                                                          *
 * You should have received a copy of the GNU General Public License                        *
 * along with RocketChatMobileEngine. If not, see <http://www.gnu.org/licenses/>.           *
 *                                                                                          *
 ********************************************************************************************/



#ifndef ROCKETCHATUSER_H
#define ROCKETCHATUSER_H

#include <QObject>

class RocketChatUser : public QObject
{
        Q_OBJECT

    public:

        enum class status {
            ONLINE,
            AWAY,
            OFFLINE
        };
        explicit RocketChatUser( QString pUsername )                                            ;

        QString getUserName() const;
        void setUserName( const QString &pValue );

        QString getSurname() const;
        void setSurname( const QString &pValue );

        QString getLastname() const;
        void setLastname( const QString &pValue );

        QString getUserId() const;
        void setUserId( const QString &pValue );

        status getStatus() const;
        void setStatus( status );

    private:
        QString mUserName;
        QString mSurname;
        QString mLastname;
        QString mUserId;
        status mStatus = status::OFFLINE;
    signals:

    public slots:
};

#endif // ROCKETCHATUSER_H
